datablock AudioProfile(M4FireSound)
{
   filename    = "./M4fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M4ReloadSound)
{
   filename    = "./M4Reload.wav";
   description = AudioClose3d;
   preload = true;
};


AddDamageType("M4",   '<bitmap:add-ons/Weapon_TacticalWeps/CI_M4> %1',    '%2 <bitmap:add-ons/Weapon_TacticalWeps/CI_M4> %1',0.2,1);
datablock ProjectileData(M4Projectile)
{
   projectileShapeName = "Add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 45;
   directDamageType    = $DamageType::M4;
   radiusDamageType    = $DamageType::M4;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse             = 400;
   verticalImpulse          = 400;
   explosion           = vectorExplosion;
   particleEmitter     = ""; //bulletTrailEmitter;

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.3;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "M4 Bullet";
};

//////////
// item //
//////////
datablock ItemData(M4Item)
{
        category = "Weapon";  // Mission editor category
        className = "Weapon"; // For inventory system

         // Basic Item Properties
        shapeFile = "./M4Shotgun.dts";
        rotate = false;
        mass = 1;
        density = 0.2;
        elasticity = 0.2;
        friction = 0.6;
        emap = true;

        //gui stuff
        uiName = "M4 Shotgun";
        iconName = "./UI_M4";
        doColorShift = true;
        colorShiftColor = "0.25 0.25 0.25 1.000";

         // Dynamic properties defined by the scripts
        image = M4Image;
        canDrop = true;
   	maxAmmo = 6;
   	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(M4Image)
{
   // Basic Item properties
   shapeFile = "./M4Shotgun.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = M4Item;
   ammo = " ";
   projectile = M4Projectile;
   projectileType = Projectile;

        casing = TacticalShellDebris;
           shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = M4Item.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
 stateName[0]    = "Activate";
 stateTimeoutValue[0]   = 0.3;
 stateWaitForTimeout[0]   = true;
 stateTransitionOnTimeout[0]  = "LoadCheckA";
 stateSound[0]    = weaponSwitchSound;
 
 stateName[1]                     = "Ready";
 stateTransitionOnTriggerDown[1]  = "Fire";
 stateAllowImageChange[1]         = true;
 stateTimeoutValue[1]   = 0.04;
 stateTransitionOnNoAmmo[1]  = "Reload";
 
 stateName[2]                     = "Fire";
 stateTransitionOnTimeout[2]      = "FireLoadCheckA";
 stateTimeoutValue[2]             = 0.06;
 stateFire[2]                     = true;
 stateAllowImageChange[2]         = false;
 stateSequence[2]   = "Fire";
 stateScript[2]    = "onFire";
 stateWaitForTimeout[2]   = true;
 stateEmitter[2]    = gunFlashEmitter;
 stateEmitterTime[2]   = 0.06;
 stateEmitterNode[2]   = "muzzleNode";
 stateSound[2]    = M4FireSound;
  stateEjectShell[2] = true;  
 
 stateName[4]    = "LoadCheckA";
 stateScript[4]    = "onLoadCheck";
 stateTimeoutValue[4]   = 0.01;
 stateTransitionOnTimeout[4]  = "LoadCheckB";
 
         stateName[5]                                = "LoadCheckA";
        stateScript[5]                                = "onLoadCheck";
        stateTimeoutValue[5]                        = 0.01;
        stateTransitionOnTimeout[5]                = "LoadCheckB";
                                                
        stateName[6]                                = "LoadCheckB";
        stateTransitionOnAmmo[6]                = "Ready";
        stateTransitionOnNoAmmo[6]                = "ForceReload";
        
        stateName[7]                                = "ReloadCheckA";
        stateScript[7]                                = "onReloadCheck";
        stateTimeoutValue[7]                        = 0.01;
        stateTransitionOnTimeout[7]                = "ReloadCheckB";
                                                
        stateName[8]                                = "ReloadCheckB";
        stateTransitionOnAmmo[8]                = "CompleteReload";
        stateTransitionOnNoAmmo[8]                = "Reload";
                                                
        stateName[9]                                = "ForceReload";
        stateTransitionOnTimeout[9]             = "ForceReloaded";
        stateTimeoutValue[9]                        = 0.3;
//        stateSequence[9]                        = "Reload";
        stateSound[9]                                = HBlock_MoveBrick_Sound;
        stateScript[9]                                = "onReloadStart";
        
        stateName[10]                                = "ForceReloaded";
        stateTransitionOnTimeout[10]             = "ReloadCheckA";
        stateTimeoutValue[10]                        = 0.2;
        stateScript[10]                                = "onReloaded";
        
        stateName[11]                                = "Reload";
        stateTransitionOnTimeout[11]             = "Reloaded";
        stateTransitionOnTriggerDown[11]        = "Fire";
        stateWaitForTimeout[11]                        = false;
        stateTimeoutValue[11]                        = 0.53;
//        stateSequence[11]                        = "Fire";
        stateSound[11]                                = HBlock_MoveBrick_Sound;
        stateScript[11]                                = "onReloadStart";
        
        stateName[12]                                = "Reloaded";
        stateTransitionOnTimeout[12]             = "ReloadCheckA";
        stateTransitionOnTriggerDown[12]        = "Fire";
        stateWaitForTimeout[12]                        = false;
        stateTimeoutValue[12]                        = 0.2;
        stateScript[12]                                = "onReloaded";

        stateName[13]                                  = "CompleteReload";
        stateTimeoutValue[13]                          = 0.5;
        stateTransitionOnTriggerUp[13]                  = "Ready";
        stateWaitForTimeout[13]                          = true;
        stateSequence[13]                        = "Fire";
};
function M4Image::onFire(%this,%obj,%slot)
{

        %obj.toolAmmo[%obj.currTool]--;
	commandToClient(%obj.client,'bottomPrint',"<color:0aa000><just:right><font:impact:38>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ "6 " @ "", 4, 2, 3, 4);
 
        if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
                return;
        %obj.lastFireTime = getSimTime();
      
        %obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.client.player.getEyeVector(),"-3")));
        %obj.playThread(2, plant);

        %projectile = %this.projectile;
        %spread = 0.0023;
        %shellcount = 3;

        for(%shell=0; %shell<%shellcount; %shell++)
        {
                %vector = %obj.getMuzzleVector(%slot);
                %objectVelocity = %obj.getVelocity();
                %vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
                %vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
                %velocity = VectorAdd(%vector1,%vector2);
                %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
                %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
                %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
                %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
                %velocity = MatrixMulVector(%mat, %velocity);

                %p = new (%this.projectileType)()
                {
                        dataBlock = %projectile;
                        initialVelocity = %velocity;
                        initialPosition = %obj.getMuzzlePoint(%slot);
                        sourceObject = %obj;
                        sourceSlot = %slot;
                        client = %obj.client;
                };
                MissionCleanup.add(%p);
        }
        return %p;
}

function M4Image::onReloadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] < %this.item.maxAmmo && %this.item.maxAmmo > 0 && %obj.getState() !$= "Dead")
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function M4Image::onReloaded(%this,%obj,%slot)
{
        %obj.playThread(2, shiftLeft);

	%obj.toolAmmo[%obj.currTool]++;
        %obj.setImageAmmo(%slot,1);

	commandToClient(%obj.client,'bottomPrint',"<color:0aa000><just:right><font:impact:38>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ "6 " @ "", 4, 2, 3, 4);
}
datablock ShapeBaseImageData(M4RunningImage)
{
   shapeFile = "./M4ShotgunRun.dts";
   emap = true;

   mountPoint = 0;
   offset = "-0.8 -0.5 -0.3";
   eyeOffset = 0;
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleM4 = true;

   className = "WeaponImage";
   item = M4Item;
   ammo = " ";
   projectile = "";
   projectileType = Projectile;

   melee = false;
   armReady = true;

   doColorShift = false;
   colorShiftColor = M4Item.colorShiftColor;//"0.400 0.196 0 1.000";

   casing = " ";

        stateName[0]                     = "Activate";
        stateTimeoutValue[0]             = 0.15;
        stateTransitionOnTimeout[0]       = "Ready";
        stateSound[0]                                        = weaponSwitchSound;
};

package M4Switch
{
          function Armor::onTrigger(%this, %player, %slot, %val)

        {

                if(isObject(%player.getMountedImage(0)))

                {

                        if((%player.getMountedImage(0).getName() $= "M4Image" || %player.getMountedImage(0).getName() $= "M4RunningImage") && %slot $= 4 && %val)

                        {

                                switch$(%player.getMountedImage(0).getName())

                                {

        

                                        case "M4Image":

                                                %player.mountImage(M4RunningImage,0);

                                        case "M4RunningImage":

                                                %player.mountImage(M4Image,0);

                                }

                         

                        }

                        else

                        {

                                Parent::onTrigger(%this, %player, %slot, %val);

                        }

                }

                else

                {

                        Parent::onTrigger(%this, %player, %slot, %val);

                }

        }
};
ActivatePackage(M4Switch);

function M4RunningImage::onMount(%this,%obj,%slot)
{
        %obj.client.player.tacticalWeapons_lastDatablock = %obj.client.player.getDatablock();

        %obj.client.player.setDataBlock("GunSprintArmor");
        
        %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function M4RunningImage::onUnMount(%this,%obj,%slot)
{        
        %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
        
        %client = %obj.client;
                if(isObject(%client.player.tacticalWeapons_lastDatablock))
                {
                        %client.player.setDataBlock(%client.player.tacticalWeapons_lastDatablock);
                }else{
                       %client.player.setDataBlock("PlayerStandardArmor");
                }
}

