datablock AudioProfile(AresFireSound)
{
  filename = "./Aresfire.wav";
  description = AudioClose3d;
  preload = true;
};

AddDamageType("Ares",   '<bitmap:Add-ons/Weapon_TacticalWeps/CI_Ares> %1',    '%2 <bitmap:Add-Ons/Weapon_TacticalWeps/CI_Ares> %1',0.2,1);
datablock ProjectileData(AresProjectile)
{
   projectileShapeName = "Add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 10;
   directDamageType    = $DamageType::Ares;
//   radiusDamageType    = $DamageType::Ares;
   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground
   impactImpulse             = 0;
   verticalImpulse          = 0;
   explosion           = vectorExplosion;
   particleEmitter     = ""; //bulletTrailEmitter;
   muzzleVelocity      = 90;
   velInheritFactor    = 1;
   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.0;
   bounceFriction      = 0.0;
   isBallistic         = false;
   gravityMod = 0.25;
   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   uiName = "Ares Shrike Bullet";
};
//### Item
datablock ItemData(AresItem)
{
  uiName = "Ares Shrike"; 
  iconName = "./UI_Ares";
  image = AresImage;
  category = Weapon;
  className = Weapon;
  shapeFile = "./ARES.dts";
  mass = 1;
  density = 0.2;
  elasticity = 0;
  friction = 0.6;
  emap = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  canDrop = true;
   maxAmmo = 100; 
   canReload = 1;
};
//### Item Image
datablock shapeBaseImageData(AresImage)
{
  shapeFile = "./ARES.dts";
  emap = true;
  correctMuzzleVector = true;
  className = "WeaponImage";
  ammo = "";
  casing = gunShellDebris;
     shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;
   shellVelocity       = 5.0;
  melee = false;
  doReaction = false;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  
     className = "WeaponImage";
   // Projectile && Ammo.
   item = AresItem;
   projectile = AresProjectile;
   projectileType = Projectile;
 stateName[0]    = "Activate";
 stateTimeoutValue[0]   = 0.3;
 stateWaitForTimeout[0]   = true;
 stateTransitionOnTimeout[0]  = "LoadCheckA";
 stateSound[0]    = weaponSwitchSound;
 
 stateName[1]                     = "Ready";
 stateTransitionOnTriggerDown[1]  = "Fire";
 stateAllowImageChange[1]         = true;
 stateTimeoutValue[1]   = 0.01;
 stateTransitionOnNoAmmo[1]  = "Reload";
 stateName[2]                     = "Fire";
 stateTransitionOnTimeout[2]      = "FireLoadCheckA";
 stateTimeoutValue[2]             = 0.06;
 stateFire[2]                     = true;
 stateAllowImageChange[2]         = false;
 stateSequence[2]   = "Fire";
 stateScript[2]    = "onFire";
 stateWaitForTimeout[2]   = true;
 stateEmitter[2]    = gunFlashEmitter;
 stateEmitterTime[2]   = 0.06;
 stateEmitterNode[2]   = "muzzleNode";
 stateSound[2]    = AresFireSound;
 stateEjectShell[2] = true;  
        stateName[4]                                = "LoadCheckA";
        stateScript[4]                                = "onLoadCheck";
        stateTimeoutValue[4]                        = 0.01;
        stateTransitionOnTimeout[4]                = "LoadCheckB";
        
        stateName[5]                                = "LoadCheckB";
        stateTransitionOnAmmo[5]                = "Ready";
        stateTransitionOnNoAmmo[5]                = "Reload";
        stateName[6]                                = "Reload";
        stateTimeoutValue[6]                        = 1.4;
        stateScript[6]                                = "onReloadStart";
        stateTransitionOnTimeout[6]                = "Wait";
        stateWaitForTimeout[6]                        = true;
        stateSound[6]                                = HBlock_MoveBrick_Sound;
        
        stateName[7]                                = "Wait";
        stateTimeoutValue[7]                        = 0.8;
        stateScript[7]                                = "onReloaded";
        stateTransitionOnTimeout[7]                = "Ready";
        stateSound[7]                                = HBlock_PlantBrick_Sound;
        
        stateName[8]                                = "FireLoadCheckA";
        stateScript[8]                                = "onLoadCheck";
        stateTimeoutValue[8]                        = 0.03;
        stateTransitionOnTimeout[8]                = "FireLoadCheckB";
        
        stateName[9]                                = "FireLoadCheckB";
        stateTransitionOnAmmo[9]                = "Smoke";
        stateTransitionOnNoAmmo[9]                = "ReloadSmoke";
        
        stateName[10]                                 = "Smoke";
        stateEmitter[10]                        = gunSmokeEmitter;
        stateEmitterTime[10]                        = 0.3;
        stateEmitterNode[10]                        = "muzzleNode";
        stateTimeoutValue[10]                        = 0.2;
        stateTransitionOnTimeout[10]                = "Ready";
        stateTransitionOnTriggerDown[10]        = "Fire";
        
        stateName[11]                                 = "ReloadSmoke";
        stateEmitter[11]                        = gunSmokeEmitter;
        stateEmitterTime[11]                        = 0.3;
        stateEmitterNode[11]                        = "muzzleNode";
        stateTimeoutValue[11]                        = 0.2;
        stateTransitionOnTimeout[11]                = "Reload";
};
function AresImage::onReloadStart(%this,%obj,%slot)
{
        %obj.playThread(2, shiftLeft);
}
function AresImage::onReloaded(%this,%obj,%slot)
{
        %obj.playThread(2, shiftAway);
        
        %obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
        %obj.setImageAmmo(%slot,1);

	commandToClient(%obj.client,'bottomPrint',"<color:0aa000><just:right><font:impact:38>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ "100 " @ "", 4, 2, 3, 4); 
}
function AresImage::onUnMount(%this,%obj,%slot)
{
        %obj.playThread(2, root);
}
function AresImage::onFire(%this,%obj,%slot)
{ 
        %obj.toolAmmo[%obj.currTool]--;
	commandToClient(%obj.client,'bottomPrint',"<color:0aa000><just:right><font:impact:38>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ "100 " @ "", 4, 2, 3, 4); 

        if(%obj.getDamagePercent() < 1.0)
                %obj.playThread(2, plant);
                
%projectile = %this.projectile;
  %spread = 0.0008;
  %shellcount = 1;
  for(%shell=0;%shell<%shellcount;%shell++)
  {
    %vector = %obj.getMuzzleVector(%slot);
    %objectVelocity = %obj.getVelocity();
    %vector1 = VectorScale(%vector,%projectile.muzzleVelocity);
    %vector2 = VectorScale(%objectVelocity,%projectile.velInheritFactor);
    %velocity = VectorAdd(%vector1,%vector2);
    %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
    %velocity = MatrixMulVector(%mat,%velocity);
    %p = new (%this.projectileType)()
    {
      dataBlock = %projectile;
      initialVelocity = %velocity;
      initialPosition = %obj.getMuzzlePoint(%slot);
      sourceObject = %obj;
      sourceSlot = %slot;
      client = %obj.client;
    };
   MissionCleanup.add(%p);
  return %p;
  }
}

datablock ShapeBaseImageData(ARESRunningImage)
{
   shapeFile = "./AresRunning.dts";
   emap = true;

   mountPoint = 0;
   offset = "-0.8 -0.5 -0.3";
   eyeOffset = 0;
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleAres = true;

   className = "WeaponImage";
   item = BowItem;
   ammo = " ";
   projectile = "";
   projectileType = Projectile;

   melee = false;
   armReady = true;

   doColorShift = false;
   colorShiftColor = AresItem.colorShiftColor;//"0.400 0.196 0 1.000";

   casing = " ";

        stateName[0]                     = "Activate";
        stateTimeoutValue[0]             = 0.15;
        stateSound[0]                                        = weaponSwitchSound;
};


package AresSwitch
{
          function Armor::onTrigger(%this, %player, %slot, %val)

        {

                if(isObject(%player.getMountedImage(0)))

                {

                        if((%player.getMountedImage(0).getName() $= "AresImage" || %player.getMountedImage(0).getName() $= "AresRunningImage") && %slot $= 4 && %val)

                        {

                                switch$(%player.getMountedImage(0).getName())

                                {

        

                                        case "AresImage":

                                                %player.mountImage(AresRunningImage,0);

                                        case "AresRunningImage":

                                                %player.mountImage(AresImage,0);

                                }

                         

                        }

                        else

                        {

                                Parent::onTrigger(%this, %player, %slot, %val);

                        }

                }

                else

                {

                        Parent::onTrigger(%this, %player, %slot, %val);

                }

        }
};
ActivatePackage(AresSwitch);

function AresRunningImage::onMount(%this,%obj,%slot)
{
        %obj.client.player.tacticalWeapons_lastDatablock = %obj.client.player.getDatablock();

        %obj.client.player.setDataBlock("HeavySprintArmor");
        
        %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function AresRunningImage::onUnMount(%this,%obj,%slot)
{        
        %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
        
        %client = %obj.client;
                if(isObject(%client.player.tacticalWeapons_lastDatablock))
                {
                        %client.player.setDataBlock(%client.player.tacticalWeapons_lastDatablock);
                }else{
                       %client.player.setDataBlock("PlayerStandardArmor");
                }
}

