datablock AudioProfile(G36FireSound)
{
  filename = "./G36fire.wav";
  description = AudioClose3d;
  preload = true;
};
datablock AudioProfile(G36LaserSound)
{
  filename = "./laser.wav";
  description = AudioClosest3d;
  preload = true;
};


datablock ParticleData(G36LaserParticle)
{
   dragCoefficient      = 5;
   gravityCoefficient   = -0.0;
   inheritedVelFactor   = 0;
   constantAcceleration = 0.0;
   lifetimeMS           = 66;
   lifetimeVarianceMS   = 0;
   textureName          = "base/data/particles/dot";
   spinSpeed           = 0.0;
   spinRandomMin        = 0.0;
   spinRandomMax        = 0.0;
  		colors[0]	= "0.900 0.000 0.000 1.000";
		colors[1]	= "0.900 0.000 0.000 1.000";
		colors[2]	= "0.900 0.000 0.000 1.000";
   sizes[0]      = 0.05;
   sizes[1]      = 0.05;
   sizes[2]      = 0.05;
 
    	times[0] = 0;
   	times[1] = 1;

   useInvAlpha = false;
};

datablock ParticleEmitterData(G36LaserEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 88.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 0;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "G36LaserParticle";
};


//### Projectile
AddDamageType("G36",'<bitmap:Add-ons/Weapon_Tacticalweps/CI_G36> %1','%2 <bitmap:Add-ons/Weapon_Tacticalweps/CI_G36> %1',0.2,1);
datablock ProjectileData(G36Projectile)
{
   projectileShapeName = "Add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 14;
   directDamageType    = $DamageType::G36;
//   radiusDamageType    = $DamageType::G36;
   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground
   impactImpulse             = 0;
   verticalImpulse          = 0;
   explosion           = VectorExplosion;
   particleEmitter     = ""; //bulletTrailEmitter;
   muzzleVelocity      = 90;
   velInheritFactor    = 1;
   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.0;
   bounceFriction      = 0.0;
   isBallistic         = false;
   gravityMod = 0.25;
   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   uiName = "HG36C Bullet";
};
//### Item
datablock ItemData(G36Item)
{
  uiName = "G36C w/ Laser"; 
  iconName = "./UI_G36"; 
  image = G36Image;
  category = Weapon;
  className = Weapon;
  shapeFile = "./G36.dts";
  mass = 1;
  density = 0.2;
  elasticity = 0;
  friction = 0.6;
  emap = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  canDrop = true;
   maxAmmo = 25; 
   canReload = 1;
};
//### Item Image
datablock shapeBaseImageData(G36Image)
{
  shapeFile = "./G36.dts";
  emap = true;
  correctMuzzleVector = true;
  className = "WeaponImage";
  ammo = "";
  casing = gunShellDebris;
       shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;
   shellVelocity       = 5.0;
  melee = false;
  doReaction = false;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  
     className = "WeaponImage";
   // Projectile && Ammo.
   item = G36Item;
   projectile = G36Projectile;
   projectileType = Projectile;
 stateName[0]    = "Activate";
 stateTimeoutValue[0]   = 0.3;
 stateWaitForTimeout[0]   = true;
 stateTransitionOnTimeout[0]  = "LoadCheckA";
 stateSound[0]    = weaponSwitchSound;
 
 stateName[1]                     = "Ready";
 stateTransitionOnTriggerDown[1]  = "Fire";
 stateAllowImageChange[1]         = true;
 stateTimeoutValue[1]   = 0.01;
 stateTransitionOnNoAmmo[1]  = "Reload";
 stateName[2]                     = "Fire";
 stateTransitionOnTimeout[2]      = "FireLoadCheckA";
 stateTimeoutValue[2]             = 0.06;
 stateFire[2]                     = true;
 stateAllowImageChange[2]         = false;
 stateSequence[2]   = "Fire";
 stateScript[2]    = "onFire";
 stateWaitForTimeout[2]   = true;
 stateEmitter[2]    = gunFlashEmitter;
 stateEmitterTime[2]   = 0.06;
 stateEmitterNode[2]   = "muzzleNode";
 stateSound[2]    = G36fireSound;
 stateEjectShell[2] = true;  
        stateName[4]                                = "LoadCheckA";
        stateScript[4]                                = "onLoadCheck";
        stateTimeoutValue[4]                        = 0.01;
        stateTransitionOnTimeout[4]                = "LoadCheckB";
        
        stateName[5]                                = "LoadCheckB";
        stateTransitionOnAmmo[5]                = "Ready";
        stateTransitionOnNoAmmo[5]                = "Reload";
        stateName[6]                                = "Reload";
        stateTimeoutValue[6]                        = 0.6;
        stateScript[6]                                = "onReloadStart";
        stateTransitionOnTimeout[6]                = "Wait";
        stateWaitForTimeout[6]                        = true;
        stateSound[6]                                = HBlock_MoveBrick_Sound;
        
        stateName[7]                                = "Wait";
        stateTimeoutValue[7]                        = 0.4;
        stateScript[7]                                = "onReloaded";
        stateTransitionOnTimeout[7]                = "Ready";
        stateSound[7]                                = HBlock_PlantBrick_Sound;
        
        stateName[8]                                = "FireLoadCheckA";
        stateScript[8]                                = "onLoadCheck";
        stateTimeoutValue[8]                        = 0.01;
        stateTransitionOnTimeout[8]                = "FireLoadCheckB";
        
        stateName[9]                                = "FireLoadCheckB";
        stateTransitionOnAmmo[9]                = "Smoke";
        stateTransitionOnNoAmmo[9]                = "ReloadSmoke";
        
        stateName[10]                                 = "Smoke";
        stateEmitter[10]                        = gunSmokeEmitter;
        stateEmitterTime[10]                        = 0.3;
        stateEmitterNode[10]                        = "muzzleNode";
        stateTimeoutValue[10]                        = 0.2;
        stateTransitionOnTimeout[10]                = "Ready";
        stateTransitionOnTriggerDown[10]        = "Fire";
        
        stateName[11]                                 = "ReloadSmoke";
        stateEmitter[11]                        = gunSmokeEmitter;
        stateEmitterTime[11]                        = 0.3;
        stateEmitterNode[11]                        = "muzzleNode";
        stateTimeoutValue[11]                        = 0.2;
        stateTransitionOnTimeout[11]                = "Reload";
};
function G36Image::onReloadStart(%this,%obj,%slot)
{
        %obj.playThread(2, shiftLeft);
}
function G36Image::onReloaded(%this,%obj,%slot)
{
        %obj.playThread(2, shiftAway);
        
        %obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
        %obj.setImageAmmo(%slot,1);

	commandToClient(%obj.client,'bottomPrint',"<color:0aa000><just:right><font:impact:38>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ "25 " @ "", 4, 2, 3, 4); 
}
function G36Image::onUnMount(%this,%obj,%slot)
{
        %obj.playThread(2, root);
}
function G36Image::onFire(%this,%obj,%slot)
{ 
        %obj.toolAmmo[%obj.currTool]--;
	commandToClient(%obj.client,'bottomPrint',"<color:0aa000><just:right><font:impact:38>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ "25 " @ "", 4, 2, 3, 4); 

     if(%obj.getDamagePercent() < 1.0)
                %obj.playThread(2, plant);
%projectile = %this.projectile;
  %spread = 0.0010;
  %shellcount = 1;
  for(%shell=0;%shell<%shellcount;%shell++)
  {
    %vector = %obj.getMuzzleVector(%slot);
    %objectVelocity = %obj.getVelocity();
    %vector1 = VectorScale(%vector,%projectile.muzzleVelocity);
    %vector2 = VectorScale(%objectVelocity,%projectile.velInheritFactor);
    %velocity = VectorAdd(%vector1,%vector2);
    %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
    %velocity = MatrixMulVector(%mat,%velocity);
    %p = new (%this.projectileType)()
    {
      dataBlock = %projectile;
      initialVelocity = %velocity;
      initialPosition = %obj.getMuzzlePoint(%slot);
      sourceObject = %obj;
      sourceSlot = %slot;
      client = %obj.client;
    };
   MissionCleanup.add(%p);
  return %p;
  }
}

datablock ShapeBaseImageData(G36RunningImage)
{
   shapeFile = "./G36Run.dts";
   emap = true;

   mountPoint = 0;
   offset = "-0.8 -0.5 -0.3";
   eyeOffset = 0;
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleG36 = true;

   className = "WeaponImage";
   item = BowItem;
   ammo = " ";
   projectile = "";
   projectileType = Projectile;

   melee = false;
   armReady = true;

   doColorShift = false;
   colorShiftColor = G36Item.colorShiftColor;//"0.400 0.196 0 1.000";

   casing = gunShellDebris;

        stateName[0]                     = "Activate";
        stateTimeoutValue[0]             = 0.15;
        stateTransitionOnTimeout[0]       = "Ready";
        stateSound[0]                                        = weaponSwitchSound;
};
datablock shapeBaseImageData(G36LaserImage)
{
  shapeFile = "./G36.dts";
  emap = true;
  correctMuzzleVector = true;
  className = "WeaponImage";
  ammo = "";
  casing = gunShellDebris;
         shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;
   shellVelocity       = 5.0;
  melee = false;
  doReaction = false;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  
     className = "WeaponImage";
   // Projectile && Ammo.
   item = G36Item;
   projectile = G36Projectile;
   projectileType = Projectile;
   stateName[0]    = "Activate";
 stateTimeoutValue[0]   = 0.3;
 stateWaitForTimeout[0]   = true;
 stateTransitionOnTimeout[0]  = "LoadCheckA";
 stateSound[0]    = G36LaserSound;
 
 stateName[1]                     = "Ready";
 stateTransitionOnTriggerDown[1]  = "Fire";
 stateAllowImageChange[1]         = true;
 stateTimeoutValue[1]   = 0.01;
 stateTransitionOnNoAmmo[1]  = "Reload";
 stateEmitter[1]                = G36LaserEmitter;
 	stateEmitterNode[1]		= "emitterPoint";
        stateEmitterTime[1]            = 300;
 stateName[2]                     = "Fire";
 stateTransitionOnTimeout[2]      = "FireLoadCheckA";
 stateTimeoutValue[2]             = 0.06;
 stateFire[2]                     = true;
 stateAllowImageChange[2]         = false;
 stateSequence[2]   = "Fire";
 stateScript[2]    = "onFire";
 stateWaitForTimeout[2]   = true;
 stateEmitter[2]    = gunFlashEmitter;
 stateEmitterTime[2]   = 0.06;
 stateEmitterNode[2]   = "muzzleNode";
 stateSound[2]    = G36fireSound;
 stateEjectShell[2] = true;  
        stateName[4]                                = "LoadCheckA";
        stateScript[4]                                = "onLoadCheck";
        stateTimeoutValue[4]                        = 0.01;
        stateTransitionOnTimeout[4]                = "LoadCheckB";
        
        stateName[5]                                = "LoadCheckB";
        stateTransitionOnAmmo[5]                = "Ready";
        stateTransitionOnNoAmmo[5]                = "Reload";
        stateName[6]                                = "Reload";
        stateTimeoutValue[6]                        = 0.6;
        stateScript[6]                                = "onReloadStart";
        stateTransitionOnTimeout[6]                = "Wait";
        stateWaitForTimeout[6]                        = true;
        stateSound[6]                                = HBlock_MoveBrick_Sound;
        
        stateName[7]                                = "Wait";
        stateTimeoutValue[7]                        = 0.4;
        stateScript[7]                                = "onReloaded";
        stateTransitionOnTimeout[7]                = "Ready";
        stateSound[7]                                = HBlock_PlantBrick_Sound;
        
        stateName[8]                                = "FireLoadCheckA";
        stateScript[8]                                = "onLoadCheck";
        stateTimeoutValue[8]                        = 0.01;
        stateTransitionOnTimeout[8]                = "FireLoadCheckB";
        
        stateName[9]                                = "FireLoadCheckB";
        stateTransitionOnAmmo[9]                = "Smoke";
        stateTransitionOnNoAmmo[9]                = "ReloadSmoke";
        
        stateName[10]                                 = "Smoke";
        stateEmitter[10]                        = gunSmokeEmitter;
        stateEmitterTime[10]                        = 0.3;
        stateEmitterNode[10]                        = "muzzleNode";
        stateTimeoutValue[10]                        = 0.2;
        stateTransitionOnTimeout[10]                = "Ready";
        stateTransitionOnTriggerDown[10]        = "Fire";
        
        stateName[11]                                 = "ReloadSmoke";
        stateEmitter[11]                        = gunSmokeEmitter;
        stateEmitterTime[11]                        = 0.3;
        stateEmitterNode[11]                        = "muzzleNode";
        stateTimeoutValue[11]                        = 0.2;
        stateTransitionOnTimeout[11]                = "Reload";
};

function G36LaserImage::onReloadStart(%this,%obj,%slot)
{
        %obj.playThread(2, shiftLeft);
}
function G36LaserImage::onReloaded(%this,%obj,%slot)
{
        %obj.playThread(2, shiftAway);
        
        %obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
        %obj.setImageAmmo(%slot,1);

	commandToClient(%obj.client,'bottomPrint',"<color:0aa000><just:right><font:impact:38>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ "25 " @ "", 4, 2, 3, 4); 
}
function G36LaserImage::onUnMount(%this,%obj,%slot)
{
        %obj.playThread(2, root);
}
function G36LaserImage::onFire(%this,%obj,%slot)
{ 
        %obj.toolAmmo[%obj.currTool]--;
	commandToClient(%obj.client,'bottomPrint',"<color:0aa000><just:right><font:impact:38>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ "25 " @ "", 4, 2, 3, 4); 

		    if(%obj.getDamagePercent() < 1.0)
                %obj.playThread(2, plant);
         
                
%projectile = %this.projectile;
  %spread = 0.0008;
  %shellcount = 1;
  for(%shell=0;%shell<%shellcount;%shell++)
  {
    %vector = %obj.getMuzzleVector(%slot);
    %objectVelocity = %obj.getVelocity();
    %vector1 = VectorScale(%vector,%projectile.muzzleVelocity);
    %vector2 = VectorScale(%objectVelocity,%projectile.velInheritFactor);
    %velocity = VectorAdd(%vector1,%vector2);
    %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
    %velocity = MatrixMulVector(%mat,%velocity);
    %p = new (%this.projectileType)()
    {
      dataBlock = %projectile;
      initialVelocity = %velocity;
      initialPosition = %obj.getMuzzlePoint(%slot);
      sourceObject = %obj;
      sourceSlot = %slot;
      client = %obj.client;
    };
   MissionCleanup.add(%p);
  return %p;
  }
}

package G36Switch
{
          function Armor::onTrigger(%this, %player, %slot, %val)
        {
                if(isObject(%player.getMountedImage(0)))
                {
                        if((%player.getMountedImage(0).getName() $= "G36Image" || %player.getMountedImage(0).getName() $= "G36LaserImage" || %player.getMountedImage(0).getName() $= "G36RunningImage") && %slot $= 4 && %val)
                        {
                                switch$(%player.getMountedImage(0).getName())
                                {
        
                                        case "G36Image":
                                                %player.mountImage(G36RunningImage,0);
                                        case "G36RunningImage":
                                                %player.mountImage(G36Image,0);
                                        case "G36LaserImage":
                                                %player.mountImage(G36Image,0);
                                }
                         
                        }
                        else
                        {
                                Parent::onTrigger(%this, %player, %slot, %val);
                        }
                }
                else
                {
                        Parent::onTrigger(%this, %player, %slot, %val);
                }
        }
};
ActivatePackage(G36Switch);
function G36RunningImage::onMount(%this,%obj,%slot)
{
        %obj.client.player.tacticalWeapons_lastDatablock = %obj.client.player.getDatablock();

        %obj.client.player.setDataBlock("GunSprintArmor");
        
        %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function G36RunningImage::onUnMount(%this,%obj,%slot)
{        
        %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
        
        %client = %obj.client;
                if(isObject(%client.player.tacticalWeapons_lastDatablock))
                {
                        %client.player.setDataBlock(%client.player.tacticalWeapons_lastDatablock);
                }else{
                       %client.player.setDataBlock("PlayerStandardArmor");
                }
}
package G36SwitchLaser
{ 
 function serverCmdCancelBrick(%this, %player, %slot, %val, %client)
 {
  %player = %this.player;
                if(isObject(%player.getMountedImage(0)))
                {
   if(%player.getMountedImage(0).getName() $= "G36Image" || %player.getMountedImage(0).getName() $= "G36LaserImage" || %player.getMountedImage(0).getName() $= "G36RunningImage")
                        {
                                switch$(%player.getMountedImage(0).getName())
                                {
        
                                        case "G36Image":
                                                %player.mountImage(G36LaserImage,0);
                                        case "G36LaserImage":
                                                %player.mountImage(G36Image,0);
                                        case "G36runningImage":
                                                %player.mountImage(G36LaserImage,0);
                                }
                         
                        }
                        else
                        {
                                Parent::serverCmdCancelBrick(%this, %player, %slot, %val, %client);
                        }
                }
                else
                {
                        Parent::serverCmdCancelBrick(%this, %player, %slot, %val, %client);
                }
        }
};
ActivatePackage(G36SwitchLaser);


