
datablock AudioProfile(InterventionFireSound)
{
   filename    = "./interventionfire.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(interventionboltSound)
{
   filename    = "./interventionbolt.wav";
   description = AudioClose3d;
   preload = true;
};

AddDamageType("InterventionHeadshot",   '<bitmap:add-ons/Weapon_TacticalWeps/CI_interventionheadshot> %1',    '%2 <bitmap:add-ons/Weapon_TacticalWeps/CI_Interventionheadshot> %1',0.5,1);
datablock ProjectileData(InterventionProjectile)
{
   projectileShapeName = "Add-Ons/Weapon_Gun/bullet.dts";
   directDamage        = 100;
   directDamageType    = $DamageType::intervention;
   radiusDamageType    = $DamageType::intervention;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 1;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse             = 0;
   verticalImpulse          = 0;
   explosion           = vectorExplosion;


   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   

};
AddDamageType("intervention",   '<bitmap:Add-ons/Weapon_TacticalWeps/CI_intervention> %1',    '%2 <bitmap:Add-ons/Weapon_TacticalWeps/CI_intervention> %1',0.5,1);
datablock ProjectileData(interventionProjectile)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 50;
   directDamageType    = $DamageType::intervention;
   radiusDamageType    = $DamageType::intervention;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 1;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse             = 0;
   verticalImpulse          = 0;
   explosion           = vectorExplosion;


   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   

};


//////////
// item //
//////////
datablock ItemData(interventionItem)
{
        category = "Weapon";  // Mission editor category
        className = "Weapon"; // For inventory system

         // Basic Item Properties
        shapeFile = "./Intervention.dts";
        rotate = false;
        mass = 1;
        density = 0.2;
        elasticity = 0.2;
        friction = 0.6;
        emap = true;

        //gui stuff
        uiName = "Intervention";
        iconName = "./UI_Intervention";
        doColorShift = false;
        colorShiftColor = "1 1 1 1.000";

         // Dynamic properties defined by the scripts
        image = interventionImage;
        canDrop = true;
                   maxAmmo = 10; 
   canReload = 1;
};




datablock ShapeBaseImageData(interventionImage)
{
   // Basic Item properties
   shapeFile = "./Intervention.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = InterventionItem;
   ammo = " ";
   projectile = InterventionProjectile;
   projectileType = Projectile;

        casing = gunShellDebris;
        shellExitDir        = "1.0 -1.3 1.0";
        shellExitOffset     = "0 0 0";
        shellExitVariance   = 15.0;        
        shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = "1 1 1 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
// Initial start up state
              stateName[0]                            = "Activate";
        stateTimeoutValue[0]                    = 0.67;
//        stateSequence[0]                         = "Use";
        stateTransitionOnTimeout[0]             = "LoadCheckA";
        stateSound[0]                                  = weaponSwitchSound;

        stateName[1]                            = "Ready";
       stateTransitionOnTriggerDown[1]         = "Fire";
        stateTransitionOnNoAmmo[1]                = "Reload";
        stateAllowImageChange[1]                = true;

        stateName[2]                            = "Fire";
        stateTransitionOnTimeout[2]             = "interventionSmoke";
        stateTimeoutValue[2]                    = 0.1;
        stateFire[2]                            = true;
        stateAllowImageChange[2]                = false;
//        stateSequence[2]                        = "Fire";
        stateScript[2]                          = "Fire";
        stateWaitForTimeout[2]                          = true;
        stateEmitter[2]                                  = vectorFlashEmitter;
        stateEmitterTime[2]                          = 0.05;
        stateEmitterNode[2]                          = "muzzleNode";
        stateSound[2]                                  = InterventionfireSound;

        stateName[3]                                   = "interventionSmoke";
        stateEmitter[3]                                  = gunSmokeEmitter;
        stateEmitterTime[3]                          = 0.1;
        stateEmitterNode[3]                          = "muzzleNode";
        stateTimeoutValue[3]                    = 0.2;
        stateTransitionOnTimeout [3]     = "Eject";

        stateName[4]                                  = "Eject";
        stateTimeoutValue[4]                          = 0.5;
        stateTransitionOnTimeout[4]                  = "FireLoadCheckA";
        stateWaitForTimeout[4]                          = true;
        stateEjectShell[4]                         = true;
        stateSequence[4]                        = "Fire";
        stateSound[4]                                  = InterventionBoltSound;
        stateScript[4]                          = "onEject";
        
        stateName[5]                                = "LoadCheckA";
        stateScript[5]                                = "onLoadCheck";
        stateTimeoutValue[5]                        = 0.01;
        stateTransitionOnTimeout[5]                = "LoadCheckB";
        
        stateName[6]                                = "LoadCheckB";
        stateTransitionOnAmmo[6]                = "Ready";
        stateTransitionOnNoAmmo[6]                = "Reload";
        
        stateName[7]                                = "Reload";
        stateTimeoutValue[7]                        = 0.6;
        stateScript[7]                                = "onReloadStart";
        stateTransitionOnTimeout[7]                = "Wait";
        stateWaitForTimeout[7]                        = true;
        stateSound[7]                                = HBlock_MoveBrick_Sound;
        
        stateName[8]                                = "Wait";
        stateTimeoutValue[8]                        = 0.4;
        stateScript[8]                                = "onReloaded";
        stateTransitionOnTimeout[8]                = "Ready";
        stateSound[8]                                = HBlock_PlantBrick_Sound;
        
        stateName[9]                                = "FireLoadCheckA";
        stateScript[9]                                = "onLoadCheck";
        stateTimeoutValue[9]                        = 0.01;
        stateTransitionOnTimeout[9]                = "FireLoadCheckB";
        
        stateName[10]                                = "FireLoadCheckB";
        stateTransitionOnAmmo[10]                = "Smoke";
        stateTransitionOnNoAmmo[10]                = "ReloadSmoke";

        stateName[11]     = "Smoke";
        stateEmitterNode[11]   = "muzzleNode";
        stateTimeoutValue[11]   = 0.0;
        stateTransitionOnTriggerUp[11]     = "Ready";

        stateName[12]                                 = "ReloadSmoke";
        stateEmitter[12]                        = TacticalSmokeEmitter;
        stateEmitterTime[12]                        = 0.3;
        stateEmitterNode[12]                        = "muzzleNode";
        stateTimeoutValue[12]                        = 0.2;
        stateTransitionOnTimeout[12]                = "Reload";
};


function InterventionImage::onReloadStart(%this,%obj,%slot)
{
        %obj.playThread(2, shiftLeft);
}
function InterventionImage::onReloaded(%this,%obj,%slot)
{
        %obj.playThread(2, shiftAway);
        
        %obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
        %obj.setImageAmmo(%slot,1);
         commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:38>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ "10 " @ "", 4, 2, 3, 4);
}

function InterventionImage::onUnMount(%this,%obj,%slot)
{
        %obj.playThread(2, root);
}

function InterventionImage::Fire(%this,%obj,%slot)
{ 
        %obj.toolAmmo[%obj.currTool]--;
        commandToClient(%obj.client,'bottomPrint',"<color:0aa000><just:right><font:impact:38>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ "10 " @ "", 4, 2, 3, 4); 

        if(%obj.getDamagePercent() < 1.0)
                %obj.playThread(2, plant);
                
%projectile = %this.projectile;
  %spread = 0.000;
  %shellcount = 1;
  for(%shell=0;%shell<%shellcount;%shell++)
  {
    %vector = %obj.getMuzzleVector(%slot);
    %objectVelocity = %obj.getVelocity();
    %vector1 = VectorScale(%vector,%projectile.muzzleVelocity);
    %vector2 = VectorScale(%objectVelocity,%projectile.velInheritFactor);
    %velocity = VectorAdd(%vector1,%vector2);
    %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
    %velocity = MatrixMulVector(%mat,%velocity);
    %p = new (%this.projectileType)()
    {
      dataBlock = %projectile;
      initialVelocity = %velocity;
      initialPosition = %obj.getMuzzlePoint(%slot);
      sourceObject = %obj;
      sourceSlot = %slot;
      client = %obj.client;
    };
   MissionCleanup.add(%p);
  return %p;
  }
}

function InterventionProjectile::Damage(%this,%obj,%col,%fade,%pos,%normal)
{
  if(%col.getClassName() $="Player" || %col.getClassName() $= "AIPlayer")
  {
    if(%col.getClassName() $= "AIPlayer")
    {
      %oldClient = %col.client;
      %col.client = BotConnection;
      %hitBoxList = getHitbox(%obj,%col,%pos);
      %col.client = %oldClient;
    }
    else
    {
      %hitBoxList = getHitbox(%obj,%col,%pos);
    }
    if(strReplace(%hitBoxList,"headskin","BAM") $= %hitBoxList)
    {
      parent::Damage(%this,%obj,%col,%fade,%pos,%normal);
    }
    else
    {
      %col.damage(%obj,%pos,120 / %obj.getScale(),$DamageType::InterventionHeadshot);
    }
  }
  else
  {
    parent::Damage(%this,%obj,%col,%fade,%pos,%normal);
  }
}

datablock ShapeBaseImageData(InterventionRunningImage)
{
   shapeFile = "./InterventionRun.dts";
   emap = true;

   mountPoint = 0;
   offset = "-0.8 -0.5 -0.3";
   eyeOffset = 0;
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleIntervention = true;

   className = "WeaponImage";
   item = BowItem;
   ammo = " ";
   projectile = "";
   projectileType = Projectile;

   melee = false;
   armReady = true;

   doColorShift = false;
   colorShiftColor = InterventionItem.colorShiftColor;//"0.400 0.196 0 1.000";

   casing = " ";

        stateName[0]                     = "Activate";
        stateTimeoutValue[0]             = 0.15;
        stateSound[0]                                        = weaponSwitchSound;
};


package InterventionSwitch
{
          function Armor::onTrigger(%this, %player, %slot, %val)

        {

                if(isObject(%player.getMountedImage(0)))

                {

                        if((%player.getMountedImage(0).getName() $= "InterventionImage" || %player.getMountedImage(0).getName() $= "InterventionRunningImage") && %slot $= 4 && %val)

                        {

                                switch$(%player.getMountedImage(0).getName())

                                {

        

                                        case "InterventionImage":

                                                %player.mountImage(InterventionRunningImage,0);

                                        case "InterventionRunningImage":

                                                %player.mountImage(InterventionImage,0);

                                }

                         

                        }

                        else

                        {

                                Parent::onTrigger(%this, %player, %slot, %val);

                        }

                }

                else

                {

                        Parent::onTrigger(%this, %player, %slot, %val);

                }

        }
};
ActivatePackage(InterventionSwitch);

function InterventionRunningImage::onMount(%this,%obj,%slot)
{
        %obj.client.player.tacticalWeapons_lastDatablock = %obj.client.player.getDatablock();

        %obj.client.player.setDataBlock("GunSprintArmor");
        
        %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function InterventionRunningImage::onUnMount(%this,%obj,%slot)
{        
        %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
        
        %client = %obj.client;
                if(isObject(%client.player.tacticalWeapons_lastDatablock))
                {
                        %client.player.setDataBlock(%client.player.tacticalWeapons_lastDatablock);
                }else{
                       %client.player.setDataBlock("PlayerStandardArmor");
                }
}


