datablock AudioProfile(scarlFireSound)
{
  filename = "./scarlfire.wav";
  description = AudioClose3d;
  preload = true;
};

//### Projectile
AddDamageType("scarl",'<bitmap:Add-ons/Weapon_Tacticalweps/CI_scarl> %1','%2 <bitmap:Add-ons/Weapon_Tacticalweps/CI_scarl> %1',0.2,1);
datablock ProjectileData(scarlProjectile)
{
   projectileShapeName = "Add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 15;
   directDamageType    = $DamageType::scarl;
   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground
   impactImpulse             = 0;
   verticalImpulse          = 0;
   explosion           = VectorExplosion;
   particleEmitter     = ""; //bulletTrailEmitter;
   muzzleVelocity      = 90;
   velInheritFactor    = 1;
   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.0;
   bounceFriction      = 0.0;
   isBallistic         = false;
   gravityMod = 0.30;
   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   uiName = "Scar L Bullet";
};
//### Item
datablock ItemData(scarlItem)
{
  uiName = "SCAR-L"; //I be showin this to ma server
  iconName = "./UI_scarl";
  image = scarlImage;
  category = Weapon;
  className = Weapon;
  shapeFile = "./scar.dts";
  mass = 1;
  density = 0.2;
  elasticity = 0;
  friction = 0.6;
  emap = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  canDrop = true;
   maxAmmo = 27; 
   canReload = 1;
};
//### Item Image
datablock shapeBaseImageData(scarlImage)
{
  shapeFile = "./scar.dts";
  emap = true;
  correctMuzzleVector = true;
  className = "WeaponImage";
  melee = false;
  doReaction = false;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  
     className = "WeaponImage";
   // Projectile && Ammo.
   item = scarlItem;
   ammo = " ";
   projectile = scarlProjectile;
   projectileType = Projectile;
   casing = gunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;
   shellVelocity       = 5.0;
   
  stateName[0]= "Activate";
stateTimeoutValue[0]= 0.5;
stateWaitForTimeout[0]= true;
stateTransitionOnTimeout[0]= "LoadCheckA";
stateSound[0]= weaponSwitchSound;
stateName[1]                    = "Ready";
stateTransitionOnTriggerDown[1] = "Fire";
stateAllowImageChange[1]        = true;
stateTimeoutValue[1]= 0.01;
stateTransitionOnNoAmmo[1]= "Reload";
stateName[2]                    = "Fire";
stateTransitionOnTimeout[2]     = "FireLoadCheckA";
stateTimeoutValue[2]            = 0.08;
stateFire[2]                    = true;
stateAllowImageChange[2]        = false;
stateSequence[2]= "Fire";
stateScript[2]= "onFire";
stateWaitForTimeout[2]= true;
stateEmitter[2]= gunFlashEmitter;
stateEmitterTime[2]= 0.06;
stateEmitterNode[2]= "muzzleNode";
stateSound[2]= scarlfireSound;
stateEjectShell[2] = true;  
        stateName[4]                                = "LoadCheckA";
        stateScript[4]                                = "onLoadCheck";
        stateTimeoutValue[4]                        = 0.01;
        stateTransitionOnTimeout[4]                = "LoadCheckB";
        
        stateName[5]                                = "LoadCheckB";
        stateTransitionOnAmmo[5]                = "Ready";
        stateTransitionOnNoAmmo[5]                = "Reload";
        stateName[6]                                = "Reload";
        stateTimeoutValue[6]                        = 0.6;
        stateScript[6]                                = "onReloadStart";
        stateTransitionOnTimeout[6]                = "Wait";
        stateWaitForTimeout[6]                        = true;
        stateSound[6]                                = HBlock_MoveBrick_Sound;
        
        stateName[7]                                = "Wait";
        stateTimeoutValue[7]                        = 0.4;
        stateScript[7]                                = "onReloaded";
        stateTransitionOnTimeout[7]                = "Ready";
        stateSound[7]                                = HBlock_PlantBrick_Sound;
        
        stateName[8]                                = "FireLoadCheckA";
        stateScript[8]                                = "onLoadCheck";
        stateTimeoutValue[8]                        = 0.01;
        stateTransitionOnTimeout[8]                = "FireLoadCheckB";
        
        stateName[9]                                = "FireLoadCheckB";
        stateTransitionOnAmmo[9]                = "Smoke";
        stateTransitionOnNoAmmo[9]                = "ReloadSmoke";
        
        stateName[10]                                 = "Smoke";
        stateEmitter[10]                        = gunSmokeEmitter;
        stateEmitterTime[10]                        = 0.3;
        stateEmitterNode[10]                        = "muzzleNode";
        stateTimeoutValue[10]                        = 0.2;
        stateTransitionOnTimeout[10]                = "Ready";
        stateTransitionOnTriggerDown[10]        = "Fire";
        
        stateName[11]                                 = "ReloadSmoke";
        stateEmitter[11]                        = gunSmokeEmitter;
        stateEmitterTime[11]                        = 0.3;
        stateEmitterNode[11]                        = "muzzleNode";
        stateTimeoutValue[11]                        = 0.2;
        stateTransitionOnTimeout[11]                = "Reload";
};
function scarlImage::onReloadStart(%this,%obj,%slot)
{
        %obj.playThread(2, shiftLeft);
}
function scarlImage::onReloaded(%this,%obj,%slot)
{
        %obj.playThread(2, shiftAway);
        
        %obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
        %obj.setImageAmmo(%slot,1);

	commandToClient(%obj.client,'bottomPrint',"<color:0aa000><just:right><font:impact:38>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ "27 " @ "", 4, 2, 3, 4); 
}
function scarlImage::onUnMount(%this,%obj,%slot)
{
        %obj.playThread(2, root);
}
function scarlImage::onFire(%this,%obj,%slot)
{ 
        %obj.toolAmmo[%obj.currTool]--;
	commandToClient(%obj.client,'bottomPrint',"<color:0aa000><just:right><font:impact:38>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ "27 " @ "", 4, 2, 3, 4); 

        if(%obj.getDamagePercent() < 1.0)
                %obj.playThread(2, plant);
%projectile = %this.projectile;
  %spread = 0.0016;
  %shellcount = 1;
  for(%shell=0;%shell<%shellcount;%shell++)
  {
    %vector = %obj.getMuzzleVector(%slot);
    %objectVelocity = %obj.getVelocity();
    %vector1 = VectorScale(%vector,%projectile.muzzleVelocity);
    %vector2 = VectorScale(%objectVelocity,%projectile.velInheritFactor);
    %velocity = VectorAdd(%vector1,%vector2);
    %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
    %velocity = MatrixMulVector(%mat,%velocity);
    %p = new (%this.projectileType)()
    {
      dataBlock = %projectile;
      initialVelocity = %velocity;
      initialPosition = %obj.getMuzzlePoint(%slot);
      sourceObject = %obj;
      sourceSlot = %slot;
      client = %obj.client;
    };
    MissionCleanup.add(%p);
  return %p;
  }  
}

datablock ShapeBaseImageData(scarlRunningImage)
{
   shapeFile = "./scarrunning.dts";
   emap = true;

   mountPoint = 0;
   offset = "-0.4 -1 -1.50";
   eyeOffset = 0;
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = true;

   className = "WeaponImage";
   item = ScarlItem;
   ammo = " ";
   projectile = "";
   projectileType = Projectile;

   melee = false;
   armReady = true;

   doColorShift = false;
   colorShiftColor = ScarlItem.colorShiftColor;//"0.400 0.196 0 1.000";

   casing = " ";

        stateName[0]                     = "Activate";
        stateTimeoutValue[0]             = 0.15;
        stateSound[0]                                        = weaponSwitchSound;
};


package ScarlSwitch
{
          function Armor::onTrigger(%this, %player, %slot, %val)

        {

                if(isObject(%player.getMountedImage(0)))

                {

                        if((%player.getMountedImage(0).getName() $= "ScarlImage" || %player.getMountedImage(0).getName() $= "ScarlRunningImage") && %slot $= 4 && %val)

                        {

                                switch$(%player.getMountedImage(0).getName())

                                {

        

                                        case "ScarlImage":

                                                %player.mountImage(ScarlRunningImage,0);

                                        case "ScarlRunningImage":

                                                %player.mountImage(ScarlImage,0);

                                }

                         

                        }

                        else

                        {

                                Parent::onTrigger(%this, %player, %slot, %val);

                        }

                }

                else

                {

                        Parent::onTrigger(%this, %player, %slot, %val);

                }

        }
};
ActivatePackage(ScarlSwitch);

function ScarlRunningImage::onMount(%this,%obj,%slot)
{
        %obj.client.player.tacticalWeapons_lastDatablock = %obj.client.player.getDatablock();

        %obj.client.player.setDataBlock("GunSprintArmor");
        
        %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function ScarlRunningImage::onUnMount(%this,%obj,%slot)
{        
        %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
        
        %client = %obj.client;
                if(isObject(%client.player.tacticalWeapons_lastDatablock))
                {
                        %client.player.setDataBlock(%client.player.tacticalWeapons_lastDatablock);
                }else{
                       %client.player.setDataBlock("PlayerStandardArmor");
                }
}


