
//we need the gun add-on for this, so force it to load
%error = ForceRequiredAddOn("Weapon_Gun");

if(%error == $Error::AddOn_Disabled)
{
   //A bit of a hack:
   //  we just forced the gun to load, but the user had it disabled
   //  so lets make it so they can't select it
   GunItem.uiName = "";
}

if(%error == $Error::AddOn_NotFound)
{
   //we don't have the gun, so we're screwed
   error("ERROR: Weapon_TacticalWeps - required add-on Weapon_Gun not found");
}

datablock DebrisData(TacticalShellDebris)
{
 shapeFile = "./M4Shell.dts";
 lifetime = 2.0;
 minSpinSpeed = -400.0;
 maxSpinSpeed = 200.0;
 elasticity = 0.5;
 friction = 0.2;
 numBounces = 3;
 staticOnMaxBounce = true;
 snapOnMaxBounce = false;
 fade = true;
 gravModifier = 2;
};

if(isFile("Add-Ons/Sound_Blockland/server.cs"))
{
   forceRequiredAddOn("Sound_Blockland");
}
else
{

datablock AudioProfile(HBlock_MoveBrick_Sound)
   {
      filename = "base/data/sound/clickMove.wav";
      description = AudioClosest3d;
      preload = false;
   };
   datablock AudioProfile(HBlock_PlantBrick_Sound)
   {
      filename = "base/data/sound/clickPlant.wav";
      description = AudioClosest3d;
      preload = false;
   };
   
   }
   




exec("./Vector.cs"); 
exec("./M4.cs"); 
exec("./M16A3.cs");
exec("./intervention.cs");
exec("./G36.cs");
exec("./CZ.cs");
exec("./ares.cs");
exec("./smaw.cs");
exec("./Support_AmmoGuns.cs");
exec("./hitboxes.cs");
exec("./scarl.cs");



datablock PlayerData(GunSprintArmor : PlayerStandardArmor)
{
   runForce = 100 * 90;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 12;
   maxBackwardSpeed = 12;
   maxSideSpeed = 12;

   maxForwardCrouchSpeed = 7;
   maxBackwardCrouchSpeed = 7;
   maxSideCrouchSpeed = 7;

   jumpForce = 9 * 90; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

minJetEnergy = 0;
jetEnergyDrain = 0;
canJet = 0;


uiName = "";
showEnergyBar = false;

   runSurfaceAngle  = 55;
   jumpSurfaceAngle = 55;
};


datablock PlayerData(HeavySprintArmor : PlayerStandardArmor)
{
   runForce = 80 * 70;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 10;
   maxBackwardSpeed = 10;
   maxSideSpeed = 10;

   maxForwardCrouchSpeed = 7;
   maxBackwardCrouchSpeed = 7;
   maxSideCrouchSpeed = 7;

   jumpForce = 9 * 90; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

minJetEnergy = 0;
jetEnergyDrain = 0;
canJet = 0;


uiName = "";
showEnergyBar = false;

   runSurfaceAngle  = 55;
   jumpSurfaceAngle = 55;
};


