datablock AudioProfile(SMAWLoopSound)
{
   filename    = "./SMAWLoop.wav";
   description = AudioDefault3d;
   preload = false;
};

datablock AudioProfile(SMAWFireSound)
{
   filename    = "./SMAWFIre.wav";
   description = AudioDefault3d;
   preload = false;
};
datablock AudioProfile(SMAWExplodeSound)
{
   filename    = "./SMAWExplosion.wav";
   description = AudioDefault3d;
   preload = false;
};
datablock ParticleData(SMAWExplosionParticle)
{
 dragCoefficient      = 3;
 gravityCoefficient   = -0.5;
 inheritedVelFactor   = 0.2;
 constantAcceleration = 0.0;
 lifetimeMS           = 700;
 lifetimeVarianceMS   = 400;
 textureName          = "base/data/particles/cloud";
 spinSpeed  = 10.0;
 spinRandomMin  = -50.0;
 spinRandomMax  = 50.0;
 colors[0]     = "0.9 0.9 0.6 0.9";
 colors[1]     = "0.9 0.5 0.6 0.0";
 sizes[0]      = 7.0;
 sizes[1]      = 9.0;
 useInvAlpha = true;
};
datablock ParticleEmitterData(SMAWExplosionEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 3.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SMAWExplosionParticle";
   uiName = "";
   emitterNode = TenthEmitterNode;
};
datablock ParticleData(SMAWChunkExplosionParticle)
{
 dragCoefficient  = 0.1;
 windCoefficient  = 0.0;
 gravityCoefficient = 2.0;
 inheritedVelFactor = 0.0;
 constantAcceleration = 0.0;
 lifetimeMS  = 2000;
 lifetimeVarianceMS = 500;
 spinSpeed  = 10.0;
 spinRandomMin  = -50.0;
 spinRandomMax  = 50.0;
 useInvAlpha  = true;
 animateTexture  = false;
 //framesPerSec  = 1;
 textureName  = "base/data/particles/chunk";
 //animTexName  = "~/data/particles/cloud";
 // Interpolation variables
 colors[0] = "0.0 0.0 0.0 1.0";
 colors[1] = "0.0 0.0 0.0 0.0";
 sizes[0] = 0.5;
 sizes[1] = 0.5;
 times[0] = 4.0;
 times[1] = 5.0;
};
datablock ParticleEmitterData(SMAWChunkExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   lifetimeMS       = 7;
   ejectionVelocity = 15;
   velocityVariance = 5.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SMAWChunkExplosionParticle";
   useEmitterColors = true;
   uiName = "";
   emitterNode = TenthEmitterNode;
};
datablock ParticleData(SMAWExplosionRingParticle)
{
        dragCoefficient      = 3;
        gravityCoefficient   = -5;
        inheritedVelFactor   = 5;
        constantAcceleration = 0.0;
        lifetimeMS           = 525;
        lifetimeVarianceMS   = 55;
        textureName          = "base/data/particles/star1";
        spinSpeed                = 10.0;
        spinRandomMin                = -500.0;
        spinRandomMax                = 500.0;
        colors[0]     = "1 1 0.0 0.9";
        colors[1]     = "0.9 0.0 0.0 0.0";
        sizes[0]      = 15;
        sizes[1]      = 16;
        useInvAlpha = false;
};
datablock ParticleData(SMAWTrailParticle)
{
        dragCoefficient      = 3;
        gravityCoefficient   = -0.0;
        inheritedVelFactor   = 0.15;
        constantAcceleration = 0.0;
        lifetimeMS           = 1000;
        lifetimeVarianceMS   = 805;
        textureName          = "base/data/particles/cloud";
        spinSpeed                = 10.0;
        spinRandomMin                = -150.0;
        spinRandomMax                = 150.0;
        colors[0]     = "1.0 1.0 0.0 0.4";
        colors[1]     = "1.0 0.2 0.0 0.5";
   colors[2]     = "0.20 0.20 0.20 0.3";
   colors[3]     = "0.0 0.0 0.0 0.0";

        sizes[0]      = 0.25;
        sizes[1]      = 0.85;
   sizes[2]      = 0.35;
         sizes[3]      = 0.05;

   times[0] = 0.0;
   times[1] = 0.05;
   times[2] = 0.3;
   times[3] = 1.0;

        useInvAlpha = false;
};
datablock ParticleEmitterData(SMAWTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SMAWTrailParticle";

   uiName = "SMAW Trail";
};
datablock ParticleEmitterData(SMAWExplosionRingEmitter)
{
   lifetimeMS     = 1000;
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 3.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SMAWExplosionRingParticle";
   uiName = "";
};

datablock ExplosionData(SMAWExplosion)
{
   //explosionShape = "";
   explosionShape = "add-ons/weapon_rocketlauncher/explosionSphere1.dts";
        soundProfile = SMAWexplodeSound;

   lifeTimeMS = 150;

   particleEmitter = SMAWExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = SMAWExplosionRingEmitter;
    emitter[1] = SMAWExplosionChunkEmitter;
         emitter[2] = SMAWExplosionEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 20;
   lightStartColor = "1 1 1 1";
   lightEndColor = "0 0 0 0";

   damageRadius = 10;
   radiusDamage = 200;

   impulseRadius = 6;
   impulseForce = 4000;
};


AddDamageType("SMAWDirect",   '<bitmap:add-ons/Weapon_Rocket_Launcher/CI_rocket> %1',    '%2 <bitmap:add-ons/Weapon_Rocket_Launcher/CI_rocket> %1',1,1);
AddDamageType("SMAWRadius",   '<bitmap:base/client/ui/ci/bomb> %1',    '%2 <bitmap:base/client/ui/ci/bomb> %1',1,0);
datablock ProjectileData(SMAWProjectile)
{
   projectileShapeName = "add-ons/weapon_rocketlauncher/RocketProjectile.dts";
   directDamage        = 1000;
   directDamageType = $DamageType::SMAWDirect;
   radiusDamageType = $DamageType::SMAWRadius;
   impactImpulse           = 1000;
   verticalImpulse           = 1000;
   explosion           = SMAWExplosion;
      particleEmitter     = SMAWTrailEmitter;

   brickExplosionRadius = 5;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 40;             
   brickExplosionMaxVolume = 40;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 60;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   sound = SMAWLoopSound;

   muzzleVelocity      = 65;
   velInheritFactor    = 1.0;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "1 0.5 0.0";

   uiName = "SMAW Rocket";
};

//////////
// item //
//////////
datablock ItemData(SMAWItem)
{
        category = "Weapon";  // Mission editor category
        className = "Weapon"; // For inventory system

         // Basic Item Properties
        shapeFile = "./SMAW.dts";
        rotate = false;
        mass = 1;
        density = 0.2;
        elasticity = 0.2;
        friction = 0.6;
        emap = true;

        //gui stuff
        uiName = "SMAW";
        iconName = "./UI_Smaw";
        doColorShift = true;
        colorShiftColor = "0.100 0.500 0.250 1.000";

         // Dynamic properties defined by the scripts
        image = SMAWImage;
        canDrop = true;
         maxAmmo = 1; 
   canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(SMAWImage)
{
   // Basic Item properties
   shapeFile = "./SMAW.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = SMAWItem;
   ammo = " ";
   projectile = SMAWProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = 700;   

   doColorShift = true;
   colorShiftColor = SMAWItem.colorShiftColor;//"0.400 0.196 0 1.000";

   
stateName[0]    = "Activate";
 stateTimeoutValue[0]   = 0.3;
 stateWaitForTimeout[0]   = true;
 stateTransitionOnTimeout[0]  = "LoadCheckA";
 stateSound[0]    = weaponSwitchSound;
 
 stateName[1]                     = "Ready";
 stateTransitionOnTriggerDown[1]  = "Fire";
 stateAllowImageChange[1]         = true;
 stateTimeoutValue[1]   = 0.01;
 stateTransitionOnNoAmmo[1]  = "Reload";
 
 stateName[2]                     = "Fire";
 stateTransitionOnTimeout[2]      = "FireLoadCheckA";
 stateTimeoutValue[2]             = 0.06;
 stateFire[2]                     = true;
 stateAllowImageChange[2]         = false;
 stateSequence[2]   = "Fire";
 stateScript[2]    = "onFire";
 stateWaitForTimeout[2]   = true;
 stateSound[2]    = SMAWFireSound;
 
 stateName[4]    = "LoadCheckA";
 stateScript[4]    = "onLoadCheck";
 stateTimeoutValue[4]   = 0.01;
 stateTransitionOnTimeout[4]  = "LoadCheckB";
 
 stateName[5]    = "LoadCheckB";
 stateTransitionOnAmmo[5]  = "Ready";
 stateTransitionOnNoAmmo[5]  = "Reload";
 stateName[6]    = "Reload";
 stateTimeoutValue[6]   = 1.6;
 stateScript[6]    = "onReloadStart";
 stateTransitionOnTimeout[6]  = "Wait";
 stateWaitForTimeout[6]   = true;
 stateSound[6]    = HBlock_MoveBrick_Sound;
 
 stateName[7]    = "Wait";
 stateTimeoutValue[7]   = 3.0;
 stateScript[7]    = "onReloaded";
 stateTransitionOnTimeout[7]  = "Ready";
 stateSound[7]    = HBlock_PlantBrick_Sound;
 
 stateName[8]    = "FireLoadCheckA";
 stateScript[8]    = "onLoadCheck";
 stateTimeoutValue[8]   = 0.01;
 stateTransitionOnTimeout[8]  = "FireLoadCheckB";
 
 stateName[9]    = "FireLoadCheckB";
 stateTransitionOnAmmo[9]  = "Smoke";
 stateTransitionOnNoAmmo[9]  = "ReloadSmoke";
 
 stateName[10]     = "Smoke";
 stateEmitter[10]   = gunSmokeEmitter;
 stateEmitterTime[10]   = 0.3;
 stateEmitterNode[10]   = "muzzleNode";
 stateTimeoutValue[10]   = 0.2;
 stateTransitionOnTimeout[10]  = "Ready";
 
 stateName[11]     = "ReloadSmoke";
 stateEmitter[11]   = gunSmokeEmitter;
 stateEmitterTime[11]   = 0.3;
 stateEmitterNode[11]   = "muzzleNode";
 stateTimeoutValue[11]   = 0.2;
 stateTransitionOnTimeout[11]  = "Reload";
 
};
function SMAWImage::onReloadStart(%this,%obj,%slot)
{
        %obj.playThread(2, shiftLeft);
}
function SMAWImage::onReloaded(%this,%obj,%slot)
{
        %obj.playThread(2, shiftAway);
        
        %obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
        %obj.setImageAmmo(%slot,1);

	commandToClient(%obj.client,'bottomPrint',"<color:0aa000><just:right><font:impact:38>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ "1 " @ "", 4, 2, 3, 4); 
}
function SMAWImage::onUnMount(%this,%obj,%slot)
{
        %obj.playThread(2, root);
}
function SMAWImage::onFire(%this,%obj,%slot)
{ 
        %obj.toolAmmo[%obj.currTool]--;
	commandToClient(%obj.client,'bottomPrint',"<color:0aa000><just:right><font:impact:38>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ "1 " @ "", 4, 2, 3, 4); 

        if(%obj.getDamagePercent() < 1.0)
                %obj.playThread(2, plant);
                                
%projectile = %this.projectile;
  %spread = 0.0003;
  %shellcount = 1;
  for(%shell=0;%shell<%shellcount;%shell++)
  {
    %vector = %obj.getMuzzleVector(%slot);
    %objectVelocity = %obj.getVelocity();
    %vector1 = VectorScale(%vector,%projectile.muzzleVelocity);
    %vector2 = VectorScale(%objectVelocity,%projectile.velInheritFactor);
    %velocity = VectorAdd(%vector1,%vector2);
    %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
    %velocity = MatrixMulVector(%mat,%velocity);
    %p = new (%this.projectileType)()
    {
      dataBlock = %projectile;
      initialVelocity = %velocity;
      initialPosition = %obj.getMuzzlePoint(%slot);
      sourceObject = %obj;
      sourceSlot = %slot;
      client = %obj.client;
    };
   MissionCleanup.add(%p);
  return %p;
  }
}


datablock ShapeBaseImageData(SMAWRunningImage)
{
   shapeFile = "./SMAWRunning.dts";
   emap = true;

   mountPoint = 0;
   offset = "-0.8 -0.5 -0.3";
   eyeOffset = 0;
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleSMAW = true;

   className = "WeaponImage";
   item = BowItem;
   ammo = " ";
   projectile = "";
   projectileType = Projectile;

   melee = false;
   armReady = true;

   doColorShift = false;
   colorShiftColor = SMAWItem.colorShiftColor;//"0.400 0.196 0 1.000";

   casing = " ";

        stateName[0]                     = "Activate";
        stateTimeoutValue[0]             = 0.15;
        stateTransitionOnTimeout[0]       = "Ready";
        stateSound[0]                                        = weaponSwitchSound;
};

package SMAWSwitch
{
          function Armor::onTrigger(%this, %player, %slot, %val)

        {

                if(isObject(%player.getMountedImage(0)))

                {

                        if((%player.getMountedImage(0).getName() $= "SMAWImage" || %player.getMountedImage(0).getName() $= "SMAWRunningImage") && %slot $= 4 && %val)

                        {

                                switch$(%player.getMountedImage(0).getName())

                                {

        

                                        case "SMAWImage":

                                                %player.mountImage(SMAWRunningImage,0);

                                        case "SMAWRunningImage":

                                                %player.mountImage(SMAWImage,0);

                                }

                         

                        }

                        else

                        {

                                Parent::onTrigger(%this, %player, %slot, %val);

                        }

                }

                else

                {

                        Parent::onTrigger(%this, %player, %slot, %val);

                }

        }
};
ActivatePackage(SMAWSwitch);

function SMAWRunningImage::onMount(%this,%obj,%slot)
{
        %obj.client.player.tacticalWeapons_lastDatablock = %obj.client.player.getDatablock();

        %obj.client.player.setDataBlock("HeavySprintArmor");
        
        %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function SMAWRunningImage::onUnMount(%this,%obj,%slot)
{        
        %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
        
        %client = %obj.client;
                if(isObject(%client.player.tacticalWeapons_lastDatablock))
                {
                        %client.player.setDataBlock(%client.player.tacticalWeapons_lastDatablock);
                }else{
                       %client.player.setDataBlock("PlayerStandardArmor");
                }
}



