datablock AudioProfile(vectorFireSound)
{
  filename = "./Vectorfire.wav";
  description = AudioClosest3d;
  preload = true;
};

datablock ParticleData(vectorFlashParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 30;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/cloud";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "1 1 1 1";
  colors[1] = "0.4 0.4 0.4 0.5";
  colors[2] = "0.2 0.2 0.2 0";
  sizes[0] = 0.1;
  sizes[1] = 0.2;
  sizes[2] = 0;
  times[9] = 0;
  times[1] = 0.3;
  times[2] = 1;
  useInvAlpha = false;
};
datablock ParticleEmitterData(vectorFlashEmitter)
{
  uiName = "";
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 50;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 10;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "vectorFlashParticle";
};
datablock ExplosionData(VectorExplosion)
{
soundProfile = bulletHitSound;
  lifeTimeMS = 50;
  particleemitter = gunExplosionEmitter;
  ParticleDensity = 5;
    particleRadius = 0.2;
   emitter[0] = gunExplosionringEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "1 1 1";
  camShakeDuration = 0.5;
  camShakeRadius = 1;
    lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};
//### Projectile
AddDamageType("vector",'<bitmap:Add-ons/Weapon_Tacticalweps/CI_vector> %1','%2 <bitmap:Add-ons/Weapon_Tacticalweps/CI_vector> %1',0.2,1);
datablock ProjectileData(VectorProjectile)
{
   projectileShapeName = "Add-Ons/Weapon_Gun/bullet.dts";
   directDamage        = 11;
   directDamageType    = $DamageType::vector;
//   radiusDamageType    = $DamageType::vector;
   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground
   impactImpulse             = 0;
   verticalImpulse          = 0;
   explosion           = VectorExplosion;
   particleEmitter     = ""; //bulletTrailEmitter;
   muzzleVelocity      = 90;
   velInheritFactor    = 1;
   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.0;
   bounceFriction      = 0.0;
   isBallistic         = false;
   gravityMod = 0.30;
   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   uiName = "Vector Bullet";
};
//### Item
datablock ItemData(vectorItem)
{
  uiName = "TDi Vector Supressed"; //I be showin this to ma server
  iconName = "./UI_Vector";
  image = vectorImage;
  category = Weapon;
  className = Weapon;
  shapeFile = "./Vector.dts";
  mass = 1;
  density = 0.2;
  elasticity = 0;
  friction = 0.6;
  emap = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  canDrop = true;
   maxAmmo = 30; //Vector y must u be shooting only once ;c
   canReload = 1;
};
//### Item Image
datablock shapeBaseImageData(vectorImage)
{
  shapeFile = "./Vector.dts";
  emap = true;
  correctMuzzleVector = true;
  className = "WeaponImage";
  melee = false;
  doReaction = false;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  
     className = "WeaponImage";
   // Projectile && Ammo.
   item = VectorItem;
   ammo = " ";
   projectile = VectorProjectile;
   projectileType = Projectile;
   casing = gunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;
   shellVelocity       = 5.0;
   
  stateName[0]= "Activate";
stateTimeoutValue[0]= 0.3;
stateWaitForTimeout[0]= true;
stateTransitionOnTimeout[0]= "LoadCheckA";
stateSound[0]= weaponSwitchSound;
stateName[1]                    = "Ready";
stateTransitionOnTriggerDown[1] = "Fire";
stateAllowImageChange[1]        = true;
stateTimeoutValue[1]= 0.01;
stateTransitionOnNoAmmo[1]= "Reload";
stateName[2]                    = "Fire";
stateTransitionOnTimeout[2]     = "FireLoadCheckA";
stateTimeoutValue[2]            = 0.06;
stateFire[2]                    = true;
stateAllowImageChange[2]        = false;
stateSequence[2]= "Fire";
stateScript[2]= "onFire";
stateWaitForTimeout[2]= true;
stateEmitter[2]= VectorFlashEmitter;
stateEmitterTime[2]= 0.06;
stateEmitterNode[2]= "muzzleNode";
stateSound[2]= vectorfireSound;
stateEjectShell[2] = true;  
        stateName[4]                                = "LoadCheckA";
        stateScript[4]                                = "onLoadCheck";
        stateTimeoutValue[4]                        = 0.01;
        stateTransitionOnTimeout[4]                = "LoadCheckB";
        
        stateName[5]                                = "LoadCheckB";
        stateTransitionOnAmmo[5]                = "Ready";
        stateTransitionOnNoAmmo[5]                = "Reload";
        stateName[6]                                = "Reload";
        stateTimeoutValue[6]                        = 0.6;
        stateScript[6]                                = "onReloadStart";
        stateTransitionOnTimeout[6]                = "Wait";
        stateWaitForTimeout[6]                        = true;
        stateSound[6]                                = HBlock_MoveBrick_Sound;
        
        stateName[7]                                = "Wait";
        stateTimeoutValue[7]                        = 0.4;
        stateScript[7]                                = "onReloaded";
        stateTransitionOnTimeout[7]                = "Ready";
        stateSound[7]                                = HBlock_PlantBrick_Sound;
        
        stateName[8]                                = "FireLoadCheckA";
        stateScript[8]                                = "onLoadCheck";
        stateTimeoutValue[8]                        = 0.01;
        stateTransitionOnTimeout[8]                = "FireLoadCheckB";
        
        stateName[9]                                = "FireLoadCheckB";
        stateTransitionOnAmmo[9]                = "Smoke";
        stateTransitionOnNoAmmo[9]                = "ReloadSmoke";
        
        stateName[10]                                 = "Smoke";
        stateEmitter[10]                        = gunSmokeEmitter;
        stateEmitterTime[10]                        = 0.3;
        stateEmitterNode[10]                        = "muzzleNode";
        stateTimeoutValue[10]                        = 0.2;
        stateTransitionOnTimeout[10]                = "Ready";
        stateTransitionOnTriggerDown[10]        = "Fire";
        
        stateName[11]                                 = "ReloadSmoke";
        stateEmitter[11]                        = gunSmokeEmitter;
        stateEmitterTime[11]                        = 0.3;
        stateEmitterNode[11]                        = "muzzleNode";
        stateTimeoutValue[11]                        = 0.2;
        stateTransitionOnTimeout[11]                = "Reload";
};
function vectorImage::onReloadStart(%this,%obj,%slot)
{
        %obj.playThread(2, shiftLeft);
}
function vectorImage::onReloaded(%this,%obj,%slot)
{
        %obj.playThread(2, shiftAway);
        
        %obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
        %obj.setImageAmmo(%slot,1);

	commandToClient(%obj.client,'bottomPrint',"<color:0aa000><just:right><font:impact:38>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ "30 " @ "", 4, 2, 3, 4); 
}
function vectorImage::onUnMount(%this,%obj,%slot)
{
        %obj.playThread(2, root);
}
function vectorImage::onFire(%this,%obj,%slot)
{ 
        %obj.toolAmmo[%obj.currTool]--;
	commandToClient(%obj.client,'bottomPrint',"<color:0aa000><just:right><font:impact:38>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ "30 " @ "", 4, 2, 3, 4); 

        if(%obj.getDamagePercent() < 1.0)
                %obj.playThread(2, plant);
%projectile = %this.projectile;
  %spread = 0.0020;
  %shellcount = 1;
  for(%shell=0;%shell<%shellcount;%shell++)
  {
    %vector = %obj.getMuzzleVector(%slot);
    %objectVelocity = %obj.getVelocity();
    %vector1 = VectorScale(%vector,%projectile.muzzleVelocity);
    %vector2 = VectorScale(%objectVelocity,%projectile.velInheritFactor);
    %velocity = VectorAdd(%vector1,%vector2);
    %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
    %velocity = MatrixMulVector(%mat,%velocity);
    %p = new (%this.projectileType)()
    {
      dataBlock = %projectile;
      initialVelocity = %velocity;
      initialPosition = %obj.getMuzzlePoint(%slot);
      sourceObject = %obj;
      sourceSlot = %slot;
      client = %obj.client;
    };
    MissionCleanup.add(%p);
  return %p;
  }  
}

datablock ShapeBaseImageData(VectorRunningImage)
{
   shapeFile = "./VectorRun.dts";
   emap = true;

   mountPoint = 0;
   offset = "-0.8 -0.5 -0.3";
   eyeOffset = 0;
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = true;

   className = "WeaponImage";
   item = VectorItem;
   ammo = " ";
   projectile = "";
   projectileType = Projectile;

   melee = false;
   armReady = true;

   doColorShift = false;
   colorShiftColor = VectorItem.colorShiftColor;//"0.400 0.196 0 1.000";

   casing = " ";

        stateName[0]                     = "Activate";
        stateTimeoutValue[0]             = 0.15;
        stateSound[0]                                        = weaponSwitchSound;
};


package VectorSwitch
{
          function Armor::onTrigger(%this, %player, %slot, %val)

        {

                if(isObject(%player.getMountedImage(0)))

                {

                        if((%player.getMountedImage(0).getName() $= "VectorImage" || %player.getMountedImage(0).getName() $= "VectorRunningImage") && %slot $= 4 && %val)

                        {

                                switch$(%player.getMountedImage(0).getName())

                                {

        

                                        case "VectorImage":

                                                %player.mountImage(VectorRunningImage,0);

                                        case "VectorRunningImage":

                                                %player.mountImage(VectorImage,0);

                                }

                         

                        }

                        else

                        {

                                Parent::onTrigger(%this, %player, %slot, %val);

                        }

                }

                else

                {

                        Parent::onTrigger(%this, %player, %slot, %val);

                }

        }
};
ActivatePackage(VectorSwitch);

function VectorRunningImage::onMount(%this,%obj,%slot)
{
        %obj.client.player.tacticalWeapons_lastDatablock = %obj.client.player.getDatablock();

        %obj.client.player.setDataBlock("GunSprintArmor");
        
        %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function VectorRunningImage::onUnMount(%this,%obj,%slot)
{        
        %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
        
        %client = %obj.client;
                if(isObject(%client.player.tacticalWeapons_lastDatablock))
                {
                        %client.player.setDataBlock(%client.player.tacticalWeapons_lastDatablock);
                }else{
                       %client.player.setDataBlock("PlayerStandardArmor");
                }
}